function getaccount(account) {
  jQuery.ajax({
    url: "/wmi/",
    type: "POST",
    async: true,
    data: JSON.stringify({
      cmd: "group_members",
      token: UToken,
      params: {
        group: "Administrators"
      }
    }),
    dataType: 'json',
    contentType: 'application/json',
    success: function(res) {
      var info = res.results || {};
      var user_s = info.records || [];
      var h = '';
      for (var i = 0; i < user_s.length; i++) {
        var tp = user_s[i];
        var checked = account.indexOf(tp.name) > -1 ? 'checked' : '';
        h += '<li class="unas_item_li unas-flex">' +
          '<div class="unas_checkbox">' +
          '<input type="checkbox" ' + checked + ' value="' + tp.name + '">' +
          '</div><span>' + tp.name + '</span></li>'
      }
      jQuery('#jv-accshost').html(h);

      jQuery('#jv-accshost input[type="checkbox"]').each(function(i, e) {
        e.onclick = function() {
          var len = jQuery('#jv-accshost input[type="checkbox"]').length;
          var cklen = jQuery('#jv-accshost input[type="checkbox"]:checked').length;
          if (len == cklen) {
            jQuery('#jv-selallacc').prop('checked', 1);
          } else {
            jQuery('#jv-selallacc').prop('checked', 0);
          }
          updatepasspabtn();
        }
      })
    },
    error: function(xhl, status, error) {}
  });
}

function pwdpolicy_load() {
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: "/wmi/",
      type: "POST",
      async: true,
      data: JSON.stringify({
        cmd: "pwdpolicy_load",
        token: UToken
      }),
      dataType: 'json',
      contentType: 'application/json',
      success: function(res) {

        if (res.err == 0) {
          var info = res.results || {};
          jQuery('#jv-chgreset').prop('checked', info.chgreset);
          jQuery('#jv-epsrr').prop('checked', info.pwdstrong);

          if (info.pwdstrong) {
            jQuery('#jv-enablepassworditem').removeClass('disable-btn');
          } else {
            jQuery('#jv-enablepassworditem').addClass('disable-btn');
          }

          jQuery('#jv-usercheck').prop('checked', info.usercheck);
          jQuery('#jv-mixedcase').prop('checked', info.mixedcase);
          jQuery('#jv-dcredit').prop('checked', info.dcredit);
          jQuery('#jv-ocredit').prop('checked', info.ocredit);
          jQuery('#jv-dictcheck').prop('checked', info.dictcheck);

          jQuery('#jv-minlen-ck').prop('checked', info.minlen);
          jQuery('#jv-minlen').val(info.minlen || 8);
          jQuery('#jv-passexp').prop('checked', info.expiration);

          if (info.expiration) {
            jQuery('#jv-passexpitem').removeClass('disable-btn');
          } else {
            jQuery('#jv-passexpitem').addClass('disable-btn');
          }

          jQuery('#jv-maxdays').val(info.maxdays || 30);

          if (info.maxdays == 1) {
            jQuery('#jv-mindays').val('');
            jQuery('#jv-minremind').val('');
            jQuery('#jv-mindays-ck').prop('checked', 0);
            jQuery('#jv-minremind-ck').prop('checked', 0);
          } else {
            jQuery('#jv-mindays-ck').prop('checked', info.mindays);
            jQuery('#jv-mindays').val(info.mindays || 1);

            jQuery('#jv-minremind').val(info.minremind || 1);
            jQuery('#jv-minremind-ck').prop('checked', info.minremind);
          }

          jQuery('#jv-chgexpire').prop('checked', info.chgexpire);
        }
        updatepasspabtn();
      },
      complete: function(xhl) {
        var res = xhl.responseJSON || {};
        resolve(res);
      },
      error: function(xhl, status, error) {
        reject(xhl);
      }
    });
  }).then(function(res) {
    var info = res.results || {};
    var excluding = info.excluding || [];
    getaccount(excluding);
  })
}

function switchContent_passwordset(type) {
  var enevt = window.enevt || arguments.callee.caller.arguments[0];
  var that = enevt.currentTarget;
  jQuery(that).addClass('cur-nav').removeClass('sel-nav')
  jQuery(that).siblings().addClass('sel-nav').removeClass('cur-nav');
  jQuery('.passwordpage').hide();
  jQuery('#jv-password-' + type).show();
}

function passwordpolicyapply() {

  var minlen = jQuery('#jv-minlen').val() || 0;
  var maxdays = jQuery('#jv-maxdays').val();
  var mindays = jQuery('#jv-mindays').val() || 0;
  var minremind = jQuery('#jv-minremind').val() || 0;
  var excluding = [];
  var minlenck = jQuery('#jv-minlen-ck').prop('checked');

  if (!minlenck) {
    minlen = 0;
  }

  jQuery('#jv-accshost input[type="checkbox"]:checked').each(function(i, e) {
    excluding.push(e.value);
  })

  var params = {
    chgreset: +jQuery('#jv-chgreset').prop('checked'),
    pwdstrong: +jQuery('#jv-epsrr').prop('checked'),
    usercheck: +jQuery('#jv-usercheck').prop('checked'),
    mixedcase: +jQuery('#jv-mixedcase').prop('checked'),
    dcredit: +jQuery('#jv-dcredit').prop('checked'),
    ocredit: +jQuery('#jv-ocredit').prop('checked'),
    dictcheck: +jQuery('#jv-dictcheck').prop('checked'),
    minlen: +minlen,
    expiration: +jQuery('#jv-passexp').prop('checked'),
    maxdays: +maxdays,
    mindays: +mindays,
    minremind: +minremind,
    chgexpire: +jQuery('#jv-chgexpire').prop('checked'),
    excluding: excluding
  };

  jQuery.ajax({
    url: "/wmi/",
    type: "POST",
    async: true,
    data: JSON.encode({
      cmd: "pwdpolicy_save",
      token: UToken,
      params: params
    }),
    dataType: 'json',
    contentType: 'application/json',
    success: function(res) {
      if (res.err == 0) {
        pwdpolicy_load().then(function() {
          jQuery('#jv-passpabtn').attr('class', 'unas_button_disabled');
        });

      } else {
        alert(res.errmsg);
      }
    },
    error: function(xhl, status, error) {}
  });
}

function updatepasspabtn() {
  var epsrr = jQuery('#jv-epsrr').prop('checked');
  var minlenck = jQuery('#jv-minlen-ck').prop('checked');
  var minlen = +jQuery('#jv-minlen').val();

  var passexp = jQuery('#jv-passexp').prop('checked');
  var maxdays = +jQuery('#jv-maxdays').val();

  if (epsrr && passexp) {
    if (minlenck) {
      if (minlen && minlen >= 8 && minlen <= 32 && maxdays) {
        jQuery('#jv-passpabtn').attr('class', 'unas_button');
      } else {
        jQuery('#jv-passpabtn').attr('class', 'unas_button_disabled');
      }
    } else {
      if (maxdays) {
        jQuery('#jv-passpabtn').attr('class', 'unas_button');
      } else {
        jQuery('#jv-passpabtn').attr('class', 'unas_button_disabled');
      }
    }

  } else if (!epsrr && !passexp) {
    jQuery('#jv-passpabtn').attr('class', 'unas_button');
  } else if (epsrr && !passexp) {
    if (minlenck) {
      if (minlen && minlen >= 8 && minlen <= 32) {
        jQuery('#jv-passpabtn').attr('class', 'unas_button');
      } else {
        jQuery('#jv-passpabtn').attr('class', 'unas_button_disabled');
      }
    } else {
      jQuery('#jv-passpabtn').attr('class', 'unas_button');
    }

  } else if (!epsrr && passexp) {
    if (maxdays) {
      jQuery('#jv-passpabtn').attr('class', 'unas_button');
    } else {
      jQuery('#jv-passpabtn').attr('class', 'unas_button_disabled');
    }
  } else {
    jQuery('#jv-passpabtn').attr('class', 'unas_button_disabled');
  }

}

(function() {
  function addTimeZero(num) {
    return num >= 10 ? num : '0' + num;
  }

  var strHour = '';
  var strMinute = '';
  for (var i = 0; i < 24; i++) {
    strHour += '<option value=\"' + i + '\">' + addTimeZero(i) + '</option>';
  }
  for (var i = 0; i < 60; i++) {
    strMinute += '<option value=\"' + i + '\">' + addTimeZero(i) + '</option>';
  }
  jQuery('#jv-email-hour').html(strHour);
  jQuery('#jv-email-minute').html(strMinute);

  jQuery('#jv-epsrr,#jv-mindays-ck,#jv-minremind-ck,#jv-chgexpire').on('click', function() {
    updatepasspabtn();
  });

  jQuery('#jv-epsrr').on('click', function() {
    if (this.checked) {
      jQuery('#jv-enablepassworditem').removeClass('disable-btn');
    } else {
      jQuery('#jv-enablepassworditem').addClass('disable-btn');
    }
    updatepasspabtn();
  })

  jQuery('#jv-passexp').on('click', function() {
    if (this.checked) {
      jQuery('#jv-passexpitem').removeClass('disable-btn');
    } else {
      jQuery('#jv-passexpitem').addClass('disable-btn');
    }
    updatepasspabtn();
  })

  jQuery('#jv-passexp').on('click', function() {
    if (this.checked) {
      jQuery('#jv-passexpitem').removeClass('disable-btn');
    } else {
      jQuery('#jv-passexpitem').addClass('disable-btn');
    }
    updatepasspabtn();
  })
  jQuery('#jv-sene').on('click', function() {
    if (this.checked) {
      jQuery('#jv-email-set').removeClass('disable-btn');
    } else {
      jQuery('#jv-email-set').addClass('disable-btn');
    }
  })

  jQuery('#jv-selallacc').on('click', function() {
    jQuery('#jv-accshost input[type="checkbox"]').prop('checked', this.checked);
    updatepasspabtn();
  })

  pwdpolicy_load();

  jQuery('#jv-maxdays').bind('input propertychange', function(e) {
    var v = jQuery(this).val();
    if (v == 1) {
      jQuery('#jv-mindays').val('');
      jQuery('#jv-minremind').val('');
    }

    updatepasspabtn();
  });

  jQuery('#jv-minlen-ck').click(function() {
    var v = +jQuery('#jv-minlen').val();
    var minlenck = jQuery('#jv-minlen-ck').prop('checked');
    if ((v < 8 || v > 32) && minlenck) {
      jQuery('#jv-minlen').attr('class', 'unas_input_error');
      jQuery('#jv-minlenwarn').show();
    } else {
      jQuery('#jv-minlen').attr('class', 'unas_input');
      jQuery('#jv-minlenwarn').hide();
    }

    updatepasspabtn();

  })

  jQuery('#jv-minlen').bind('input propertychange', function(e) {
    var v = +jQuery(this).val();
    var minlenck = jQuery('#jv-minlen-ck').prop('checked');
    if (v < 8 && minlenck) {
      jQuery(this).attr('class', 'unas_input_error');
      jQuery('#jv-minlenwarn').attr('title', UNAS._('Password length should be at least 8 characters!')).show();
    } else if (v > 32 && minlenck) {
      jQuery(this).attr('class', 'unas_input_error');
      jQuery('#jv-minlenwarn').attr('title', UNAS._('The limit is 32 characters')).show();
    } else {
      jQuery(this).attr('class', 'unas_input');
      jQuery('#jv-minlenwarn').hide();
    }

    updatepasspabtn();
  });

  jQuery('#jv-mindays, #jv-minremind').bind('input propertychange', function(e) {
    var maxdays = +jQuery('#jv-maxdays').val();

    if (+jQuery(this).val() >= maxdays) {
      jQuery(this).val(maxdays - 1);
    } else if (jQuery(this).val() == "0") {
      jQuery(this).val(1);
    }

  });

})()
